//
//  ATColorCell.m
//  MyAnimatedTableView
//
//  Created by countryhu on 13-1-10.
//  Copyright (c) 2013年 Thunder. All rights reserved.
//

#import "ATColorCell.h"

#define INSET_FROM_IMAGE_TO_TEXT 4.0


@implementation ATColorCell

- (id)init {
    self = [super init];
    return self;
}

- (id)copyWithZone:(NSZone *)zone {
    ATColorCell *result = [super copyWithZone:zone];
    result->_color = _color;
    return result;
}

@synthesize color = _color;

- (NSRect)colorRectForFrame:(NSRect)frame {
    NSRect result = frame;
    result.size.width = frame.size.height;
    return result;
}

- (NSRect)_titleFrameForFrame:(NSRect)frame {
    NSRect colorFrame = [self colorRectForFrame:frame];
    NSRect result = colorFrame;
    result.origin.x = NSMaxX(colorFrame) + INSET_FROM_IMAGE_TO_TEXT;
    result.size.width = NSMaxX(frame) - NSMinX(result);
    NSSize naturalSize = [super cellSize];
    result.origin.y = NSMidY(frame) - naturalSize.height/2.0;
    result.size.height = naturalSize.height;
    return result;
}

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView {
    if (_color) {
        [_color set];
        NSRect colorFrame = [self colorRectForFrame:cellFrame];
        NSRectFill(colorFrame);
        [[NSColor lightGrayColor] set];
        NSFrameRectWithWidth(colorFrame, 1.0);
    }
    
    NSRect textFrame = [self _titleFrameForFrame:cellFrame];
    [super drawInteriorWithFrame:textFrame inView:controlView];
}

- (NSUInteger)hitTestForEvent:(NSEvent *)event inRect:(NSRect)cellFrame ofView:(NSView *)controlView {
    NSPoint point = [controlView convertPoint:[event locationInWindow] fromView:nil];

    NSRect colorFrame = [self colorRectForFrame:cellFrame];
    if (NSPointInRect(point, colorFrame)) {
        return NSCellHitTrackableArea;
    } else {
        return [super hitTestForEvent:event inRect:cellFrame ofView:controlView];
    }
}
@end
