//
//  NSColorView.m
//  MyAnimatedTableView
//
//  Created by countryhu on 13-1-10.
//  Copyright (c) 2013年 Thunder. All rights reserved.
//

#import "ATColorView.h"

#import <Quartz/Quartz.h>

@implementation ATColorView

+ (id)defaultAnimationForKey:(NSString *)key {
    if ([key isEqualToString:@"backgroundColor"]) {
        return [CABasicAnimation animation];
    }
    return [super defaultAnimationForKey:key];
}

@dynamic backgroundColor;
- (void)setBackgroundColor:(NSColor *)backgroundColor {
    CGFloat components[backgroundColor.numberOfComponents];
    [backgroundColor getComponents:components];
    CGColorRef backgroundColorRef = CGColorCreate([[backgroundColor colorSpace] CGColorSpace], components);
    self.layer.backgroundColor = backgroundColorRef;
    CGColorRelease(backgroundColorRef);
}

- (NSColor *)backgroundColor {
    NSColor *result = nil;
    if (self.layer != nil) {
        CGColorRef backgroundColor = self.layer.backgroundColor;
        if (backgroundColor != nil) {
            NSColorSpace *cp = [[NSColorSpace alloc] initWithCGColorSpace:CGColorGetColorSpace(backgroundColor)];
            const CGFloat *components = CGColorGetComponents(backgroundColor);
            CGFloat componentCount = CGColorGetNumberOfComponents(backgroundColor);
            result = [NSColor colorWithColorSpace:cp components:components count:componentCount];
        }
    }
    return result;
}

@end
