//
//  ATDesktopEntity.h
//  MyAnimatedTableView
//
//  Created by countryhu on 12-12-31.
//  Copyright (c) 2012年 Thunder. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// Base abstract class that wraps a filesystem URL
@interface ATDesktopEntity : NSObject {

@private
    NSURL *_fileUrl;
}

-(id)initWithFileUrl:(NSURL *)fileUrl;
-(NSString *)title;

@property(retain)NSURL *fileUrl;

@end

// Concrete subclass of ATDesktopEntity that loads children from a folder
@interface ATDesktopFolderEntity : ATDesktopEntity {
@private
    NSArray *_children;
}

@property(readonly, retain)NSArray *children;

@end

// Concrete subclass of ATDesktopEntity that storage image
@interface ATDesktopImageEntity : ATDesktopEntity {
    NSImage *_image;
    NSImage *_thumbnailImage;
    NSString *_fillColorName;
    NSColor *_fillColor;
}

@property(retain, readwrite)NSImage *image;
@property(retain, readwrite)NSImage *thumbnailImage;
@property(copy)NSString *fillColorName;
@property(retain)NSColor *fillColor;

-(id)initWithFileUrl:(NSURL *)fileUrl;

@end
